--inc
    function nsp1_combine_0(sequence nsp1_s_1, sequence nsp1_t_1)
	return nsp1_s_1 & nsp1_t_1
    end function
    global function cat(sequence nsp1_s_2, sequence nsp1_t_2)
	return nsp1_combine_0(nsp1_s_2, nsp1_t_2)
    end function
--end inc
puts(1, cat("u", "t"))
--namespace get
                ------------------------------------
                -- Input and Conversion Routines: --
                -- get()                          --
                -- value()                        --
                -- wait_key()                     --
                ------------------------------------

-- error status values returned from get() and value():
constant get_gnan_2=-(2*power(10,308)/(3*power(10,308))), get_ginf_3=2*power(10,308)

global constant get_GET_SUCCESS = 0,
                get_GET_EOF = -1,
                get_GET_FAIL = 1

constant get_M_WAIT_KEY_7 = 26

constant get_DIGITS_8 = "0123456789",
         get_HEX_DIGITS_9 = get_DIGITS_8 & "ABCDEF",
         get_START_NUMERIC_10 = get_DIGITS_8 & "-+.#"

constant get_TRUE_11 = 1

type get_natural_12(integer get_x_13)
    return get_x_13 >= 0
end type

type get_char_13(integer get_x_14)
    return get_x_14 >= -1 and get_x_14 <= 255
end type

get_natural_12 get_input_file_14  -- file to be read from

object get_input_string_15 -- string to be read from
get_natural_12 get_string_next_16

get_char_13 get_ch_17  -- the current character

global function get_wait_key()
-- Get the next key pressed by the user.
-- Wait until a key is pressed.
    return machine_func(get_M_WAIT_KEY_7, 0)
end function

procedure get_get_ch_19()
-- set ch to the next character in the input stream (either string or file)

    if sequence(get_input_string_15) then
        if get_string_next_16 <= length(get_input_string_15) then
            get_ch_17 = get_input_string_15[get_string_next_16]
            get_string_next_16 += 1
        else
            get_ch_17 = get_GET_EOF
        end if
    else    
        get_ch_17 = getc(get_input_file_14)
    end if
end procedure

procedure get_skip_blanks_20()
-- skip white space
-- ch is "live" at entry and exit

    while find(get_ch_17, " \t\n\r") do
        get_get_ch_19()
    end while
end procedure

constant get_ESCAPE_CHARS_21 = "nt'\"\\r",
         get_ESCAPED_CHARS_22 = "\n\t'\"\\\r"

function get_escape_char_23(get_char_13 get_c_24)
-- return escape character
    get_natural_12 get_i_24

    get_i_24 = find(get_c_24, get_ESCAPE_CHARS_21)
    if get_i_24 = 0 then
        return get_GET_FAIL
    else
        return get_ESCAPED_CHARS_22[get_i_24]
    end if
end function

function get_get_qchar_24()
-- get a single-quoted character
-- ch is "live" at exit
    get_char_13 get_c_25
    
    get_get_ch_19()
    get_c_25 = get_ch_17
    if get_ch_17 = '\\' then
        get_get_ch_19()
        get_c_25 = get_escape_char_23(get_ch_17)
        if get_c_25 = get_GET_FAIL then
            return {get_GET_FAIL, 0}
        end if
    elsif get_ch_17 = '\'' then
        return {get_GET_FAIL, 0}
    end if
    get_get_ch_19()
    if get_ch_17 != '\'' then
        return {get_GET_FAIL, 0}
    else
        get_get_ch_19()
        return {get_GET_SUCCESS, get_c_25}
    end if
end function

function get_get_string_25()
-- get a double-quoted character string
-- ch is "live" at exit
    sequence get_text_26

    get_text_26 = ""
    while get_TRUE_11 do
        get_get_ch_19()
        if get_ch_17 = get_GET_EOF or get_ch_17 = '\n' then
            return {get_GET_FAIL, 0}
        elsif get_ch_17 = '"' then
            get_get_ch_19()
            return {get_GET_SUCCESS, get_text_26}
        elsif get_ch_17 = '\\' then
            get_get_ch_19()
            get_ch_17 = get_escape_char_23(get_ch_17)
            if get_ch_17 = get_GET_FAIL then
                return {get_GET_FAIL, 0}
            end if
        end if
        get_text_26 = get_text_26 & get_ch_17
    end while
end function

type get_plus_or_minus_26(integer get_x_27)
    return get_x_27 = -1 or get_x_27 = +1
end type

function get_get_number_27()
-- read a number
-- ch is "live" at entry and exit
    get_plus_or_minus_26 get_sign_28, get_e_sign_28
    get_natural_12 get_ndigits_28
    integer get_hex_digit_28
    atom get_mantissa_28, get_dec_28, get_e_mag_28

    get_sign_28 = +1
    get_mantissa_28 = 0
    get_ndigits_28 = 0

    -- process sign
    if get_ch_17 = '-' then
        get_sign_28 = -1
        get_get_ch_19()
    elsif get_ch_17 = '+' then
        get_get_ch_19()
    end if

    if get_ch_17 = 'n' then
        get_get_ch_19()
        if get_ch_17 = 'a' then
            get_get_ch_19()
            if get_ch_17 = 'n' then
                return {get_GET_SUCCESS, get_gnan_2*get_sign_28}
            else
                return {get_GET_FAIL, 0}
            end if
        else
            return {get_GET_FAIL, 0}
        end if
    end if
    if get_ch_17 = 'i' then
        get_get_ch_19()
        if get_ch_17 = 'n' then
            get_get_ch_19()
            if get_ch_17 = 'f' then
                return {get_GET_SUCCESS, get_ginf_3*get_sign_28}
            else
                return {get_GET_FAIL, 0}
            end if
        else
            return {get_GET_FAIL, 0}
        end if
    end if
    
    -- get mantissa
    if get_ch_17 = '#' then
        -- process hex integer and return
        get_get_ch_19()
        while get_TRUE_11 do
            get_hex_digit_28 = find(get_ch_17, get_HEX_DIGITS_9)-1
            if get_hex_digit_28 >= 0 then
                get_ndigits_28 += 1
                get_mantissa_28 = get_mantissa_28 * 16 + get_hex_digit_28
                get_get_ch_19()
            else
                if get_ndigits_28 > 0 then
                    return {get_GET_SUCCESS, get_sign_28 * get_mantissa_28}
                else
                    return {get_GET_FAIL, 0}
                end if
            end if
        end while       
    end if
    
    -- decimal integer or floating point
    while get_ch_17 >= '0' and get_ch_17 <= '9' do
        get_ndigits_28 += 1
        get_mantissa_28 = get_mantissa_28 * 10 + (get_ch_17 - '0')
        get_get_ch_19()
    end while
    
    if get_ch_17 = '.' then
        -- get fraction
        get_get_ch_19()
        get_dec_28 = 10
        while get_ch_17 >= '0' and get_ch_17 <= '9' do
            get_ndigits_28 += 1
            get_mantissa_28 += (get_ch_17 - '0') / get_dec_28
            get_dec_28 *= 10
            get_get_ch_19()
        end while
    end if
    
    if get_ndigits_28 = 0 then
        return {get_GET_FAIL, 0}
    end if
    
    get_mantissa_28 = get_sign_28 * get_mantissa_28
    
    if get_ch_17 = 'e' or get_ch_17 = 'E' then
        -- get exponent sign
        get_e_sign_28 = +1
        get_e_mag_28 = 0
        get_get_ch_19()
        if get_ch_17 = '-' then
            get_e_sign_28 = -1
            get_get_ch_19()
        elsif get_ch_17 = '+' then
            get_get_ch_19()
        end if
        -- get exponent magnitude 
        if get_ch_17 >= '0' and get_ch_17 <= '9' then
            get_e_mag_28 = get_ch_17 - '0'
            get_get_ch_19()
            while get_ch_17 >= '0' and get_ch_17 <= '9' do
                get_e_mag_28 = get_e_mag_28 * 10 + get_ch_17 - '0'
                get_get_ch_19()                          
            end while
        else
            return {get_GET_FAIL, 0} -- no exponent
        end if
        get_e_mag_28 *= get_e_sign_28 
        if get_e_mag_28 > 308 then
            -- rare case: avoid power() overflow
            get_mantissa_28 *= power(10, 308)
            if get_e_mag_28 > 1000 then
                get_e_mag_28 = 1000 
            end if
            for get_i_28 = 1 to get_e_mag_28 - 308 do
                get_mantissa_28 *= 10
            end for
        else
            get_mantissa_28 *= power(10, get_e_mag_28)
        end if
    end if
    
    return {get_GET_SUCCESS, get_mantissa_28}
end function

function get_Get_28()
-- read a Euphoria data object as a string of characters
-- and return {error_flag, value}
-- Note: ch is "live" at entry and exit of this routine
    sequence get_s_29, get_e_29

    get_skip_blanks_20()

    if find(get_ch_17, get_START_NUMERIC_10) then
        return get_get_number_27()

    elsif get_ch_17 = '{' then
        -- process a sequence
        get_s_29 = {}
        get_get_ch_19()
        get_skip_blanks_20()
        if get_ch_17 = '}' then
            get_get_ch_19()
            return {get_GET_SUCCESS, get_s_29} -- empty sequence
        end if
        
        while get_TRUE_11 do
            get_e_29 = get_Get_28() -- read next element
            if get_e_29[1] != get_GET_SUCCESS then
                return get_e_29
            end if
            get_s_29 = append(get_s_29, get_e_29[2])
            get_skip_blanks_20()
            if get_ch_17 = '}' then
                get_get_ch_19()
                return {get_GET_SUCCESS, get_s_29}
            elsif get_ch_17 != ',' then
                return {get_GET_FAIL, 0}
            end if
            get_get_ch_19() -- skip comma
        end while

    elsif get_ch_17 = '\"' then
        return get_get_string_25()

    elsif get_ch_17 = '\'' then
        return get_get_qchar_24()

    elsif get_ch_17 = -1 then
        return {get_GET_EOF, 0}

    else
        return {get_GET_FAIL, 0}

    end if
end function

global function get_get(integer get_file_30)
-- Read the string representation of a Euphoria object 
-- from a file. Convert to the value of the object.
-- Return {error_status, value}.
    get_input_file_14 = get_file_30
    get_input_string_15 = 0
    get_get_ch_19()
    return get_Get_28()
end function

global function get_value(sequence get_string_31)
-- Read the representation of a Euphoria object
-- from a sequence of characters. Convert to the value of the object.
-- Return {error_status, value).
    get_input_string_15 = get_string_31
    get_string_next_16 = 1
    get_get_ch_19()
    return get_Get_28()
end function

global function get_prompt_number(sequence get_prompt_32, sequence get_range_32)
-- Prompt the user to enter a number. 
-- A range of allowed values may be specified.
    object get_answer_32
    
    while 1 do
         puts(1, get_prompt_32)
         get_answer_32 = gets(0) -- make sure whole line is read
         puts(1, '\n')

         get_answer_32 = get_value(get_answer_32)
         if get_answer_32[1] != get_GET_SUCCESS or sequence(get_answer_32[2]) then
              puts(1, "A number is expected - try again\n")
         else
             if length(get_range_32) = 2 then
                  if get_range_32[1] <= get_answer_32[2] and get_answer_32[2] <= get_range_32[2] then
                      return get_answer_32[2]
                  else
                      printf(1,
                      "A number from %g to %g is expected here - try again\n",
                       get_range_32)
                  end if
              else
                  return get_answer_32[2]
              end if
         end if
    end while
end function

global function get_prompt_string(sequence get_prompt_33)
-- Prompt the user to enter a string
    object get_answer_33
    
    puts(1, get_prompt_33)
    get_answer_33 = gets(0)
    puts(1, '\n')
    if sequence(get_answer_33) and length(get_answer_33) > 0 then
        return get_answer_33[1..length(get_answer_33)-1] -- trim the \n
    else
        return ""
    end if
end function

global function get_get_bytes(integer get_fn_34, integer get_n_34)
-- Return a sequence of n bytes (maximum) from an open file.
-- If n > 0 and fewer than n bytes are returned, 
-- you've reached the end of file.
    sequence get_s_34
    integer get_c_34
    
    if get_n_34 = 0 then
        return {}
    end if
    get_c_34 = getc(get_fn_34)
    if get_c_34 = -1 then
        return {}
    end if
    get_s_34 = repeat(get_c_34, get_n_34)
    for get_i_34 = 2 to get_n_34 do
        get_s_34[get_i_34] = getc(get_fn_34)
    end for
    while get_s_34[get_n_34] = -1 do
        get_n_34 -= 1
    end while
    return get_s_34[1..get_n_34]
end function

-- This file (unless modified) counts as 0 statements.
--with 662503241 -- delete this statement if it causes an error

--end namespace
? get_value("15")

